/* Test invocation of a nested function in a dynamically opened shared library.  */

#include <dlfcn.h>
#include <stdio.h>

extern void debug_info (void);

int
main ()
{
  void *array[5] = { "abc", NULL, "def", "rst", NULL };

  debug_info ();

  void *handle = dlopen ("./libnested.so", RTLD_LAZY);
  unsigned int (*count_nonnull_entries) (void **array, unsigned int size) =
    dlsym (handle, "count_nonnull_entries");

  debug_info ();

  unsigned int count = count_nonnull_entries (array, 5);
  printf ("count = %u\n", count);
}

/*
 * Local Variables:
 * compile-command: "gcc -Wall -shared -fPIC -o libnested.so nested1.c nested2.c; gcc -Wall nested-in-dl-sharedlib.c debug.c -ldl"
 * End:
 */
