/* Test invocation of a nested function in a dynamically opened shared library in a separate thread.  */

#include <dlfcn.h>
#include <pthread.h>
#include <stdio.h>

extern void debug_info (void);

static void *thread_func (void *ignored)
{
  void *array[5] = { "abc", NULL, "def", "rst", NULL };

  debug_info ();

  void *handle = dlopen ("./libnested.so", RTLD_LAZY);
  unsigned int (*count_nonnull_entries) (void **array, unsigned int size) =
    dlsym (handle, "count_nonnull_entries");

  debug_info ();

  unsigned int count = count_nonnull_entries (array, 5);
  printf ("count = %u\n", count);

  return NULL;
}

int
main ()
{
  pthread_t thread;

  if (pthread_create (&thread, NULL, thread_func, NULL))
    {
      fprintf (stderr, "creating of thread failed\n");
      return 1;
    }

  pthread_join (thread, NULL);
}

/*
 * Local Variables:
 * compile-command: "gcc -Wall -shared -fPIC -o libnested.so nested1.c nested2.c; gcc -Wall nested-in-thread-with-dl-sharedlib.c debug.c -ldl -lpthread"
 * End:
 */
