/* Test invocation of a nested function in a separate thread.  */

#include <pthread.h>
#include <stdio.h>

extern void debug_info (void);
extern unsigned int count_nonnull_entries (void **array, unsigned int size);

static void *thread_func (void *ignored)
{
  void *array[5] = { "abc", NULL, "def", "rst", NULL };

  debug_info ();

  unsigned int count = count_nonnull_entries (array, 5);
  printf ("count = %u\n", count);

  return NULL;
}

int
main ()
{
  pthread_t thread;

  if (pthread_create (&thread, NULL, thread_func, NULL))
    {
      fprintf (stderr, "creating of thread failed\n");
      return 1;
    }

  pthread_join (thread, NULL);
}

/*
 * Local Variables:
 * compile-command: "gcc -Wall nested-in-thread.c nested1.c nested2.c debug.c -lpthread"
 * End:
 */
